<?php

/**
 * Provides utility functions for the flashpoint_commerce_course module.
 */

namespace Drupal\flashpoint_commerce_course;

use Drupal\Core\Session\AccountInterface;
use Drupal\group\Entity\GroupContent;


/**
 * Class FlashpointCommerceCourseUtilities
 * @package Drupal\flashpoint_commerce_course
 */
class FlashpointCommerceCourseUtilities {
  public static function getUnredeemedPurchases($course, AccountInterface $account) {
    // Get the applicable products
    $query = \Drupal::entityQuery('commerce_product_variation');
    $query->condition('product_id.entity.field_course', $course->id());
    $vars = $query->execute();
    $query = \Drupal::entityQuery('commerce_order_item');
    $query->condition('order_id.entity.uid', $account->id());
    $query->condition('order_id.entity.state', 'completed');
    $query->condition('purchased_entity', array_keys($vars), 'IN');
    $purchase_ids = $query->execute();

    // If we found purchase IDs, check that they weren't used already
    if ($purchase_ids) {
      $purchased = array_keys($purchase_ids);
      $query = \Drupal::entityQuery('group_content');
      $query->condition('gid', $course->id());
      $query->condition('field_redeemed_order_items', $purchase_ids, 'IN');
      $query->condition('uid', $account->id());
      $query->condition('entity_id', $account->id());
      $results = $query->execute();
      if (empty($results)) {
        return $purchased;
      }
      else {
        $ms = GroupContent::loadMultiple($results);
        foreach ($ms as $m) {
          $redeemed = $m->get('field_redeemed_order_items')->getValue();
          foreach ($redeemed as $posn => $r) {
            $purchased = array_diff($purchased, [$r['target_id']]);
          }
        }
        if (!empty($purchased)) {
          return $purchased;
        }
      }
    }
    // If we couldn't find anything, return an empty array
    return [];
  }
}