<?php

namespace Drupal\flashpoint_commerce_course\Plugin\flashpoint_access;

use Drupal\Core\Plugin\PluginBase;
use Drupal\Core\Session\AccountInterface;
use Drupal\flashpoint\FlashpointAccessMethodInterface;
use Drupal\flashpoint_commerce_course\FlashpointCommerceCourseUtilities;


/**
 * @FlashpointAccessMethod(
 *   id = "purchased_course_product",
 *   label = @Translation("Purchased Course Product"),
 *   context = "course"
 * )
 */
class PurchasedCourseProduct extends PluginBase implements FlashpointAccessMethodInterface
{

  /**
   * @return string
   *   A string description.
   */
  public function description()
  {
    return $this->t('Any purchased course product referencing this course will grant access.');
  }

  /**
   * @param $course
   * @param AccountInterface $account
   *
   * Determines whether someone has access to enroll in a course
   * @return boolean
   */
  public static function checkAccess($course, AccountInterface $account) {
    $purchased = FlashpointCommerceCourseUtilities::getUnredeemedPurchases($course, $account);
    if (!empty($purchased)) {
      return TRUE;
    }
    else {
      return FALSE;
    }
  }
}